doseresp_evt = Anon()

def doseresp_pick_example_model():
    print 'unimplemented'

def doseresp_show_presets():
    menu = gtk.Menu()
    doseresp_evt.mnuref = ref = Reffer()
    for name in qubx.settings.SettingsMgr.listNames('Simulation'):
        qubx.GTK.build_menuitem(name, ref(bind(qubx.settings.SettingsMgr['Simulation'].load, name)), menu=menu)
    menu.popup(None, None, None, 0, 0)

def doseresp_show_simdata():
    QubX.Data.request_show()
    QubX.Data.show_file('<simulation>')


doseresp_workflow = Workflow("Dose-Response",
["""Dose-Response Simulation

This window guides you through dose-response simulations. The process involves
  - setting up a state model with stimulus-dependent rates
  - setting up a stimulus protocol
  - measuring peak and integral of the simulated currents

Click "Next" to begin.

"""],
## should be 2nd paragraph below:
##  Or """, ("pick from example models", doseresp_pick_example_model), """.
##  
["""1. Set up a model

  To start, we need a state model in the """, ("Models window", "QubX.Models.request_show()"), """ (click to show).

  To build a model: click anywhere to add a state. We need states of at least two colors (classes). Right-click or long-press a state for options, including "Connect to...." another state. Adjust conductances in the """, ("Classes table", "QubX.Tables.show_table(QubX.Models.file.classes, True)"), """, and rates in the """, ("Rates table", "QubX.Tables.show_table(QubX.Models.file.rates, True"),
""".  Right-click or long-press a rate constant for options including "Ligand-sensitive" and "Voltage-sensitive."

Each rate can be sensitive to a different drug; change the name "Ligand" in the Rates table to the drug's name.  For pressure-sensitivity, choose "Voltage-sensitive" and change the name "Voltage" to "Pressure."  If current amplitudes should change with voltage, check the box "I=f(V)" (click the '?' next to it for more info).
"""],
["""2. Set up a stimulus protocol

  Protocols are in the """, ("Simulation window", "QubX.Simulation.request_show()"), """.  Either
  - """, ("pick a preset protocol", doseresp_show_presets), """,
  - use the """, ("Stimulus ladder wizard", qubx.simulate.doseresp_ladder_wizard), """ (also in the Simulation presets menu), or
  - build a custom protocol:

First, set the sampling rate and segment count. Then look by "Constants" where all of the stimuli from the model should be listed. To use a waveform instead of a constant, click "vary." There will be a choice of shapes (Custom, Step, Sine, ...) which can be clicked or dragged into place below.  To edit a shape's parameters, click it, then look under "Shape" in the main window/sidebar.

Parameters can take different values in successive segments; either as a comma-separated list, or by setting the parameter's "incr"ement -- how much to add after each segment -- or "factor" -- how much to multiply by after each segment.

"""],
["""3. Browse data and results

  Wait for simulation to finish, if necessary, then browse traces in the file named """, ("<simulation>", doseresp_show_simdata), " in the ", ("Data window", "QubX.Data.request_show()"), """.
    - """, ("one trace at a time", "QubX.Data.view.time.Gseg = 1"), """
    - """, ("all traces at once", "QubX.Data.view.time.Gseg = QubX.Data.view.time.Nseg"), """ (slower)

  """, ("Measure Dose-Response", "qubx.dataGTK.MeasureDoseResponse()"), """ (from the Data panel's Measurement/Ruler menu)
  This function also plots the results in the Charts panel and attempts to fit them to the Hill equation.
  """
])

QubX.Workflows.append_face(doseresp_workflow)
